/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../../reducers/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogActionTypes";
import {
  SET_contentAction,
  SET_displayIndexAction,
  SET_displayNameAction,
  SET_editorTest_compileTimeoutInMsAction,
  SET_editorTest_filesAction,
  SET_editorTest_maxDiskSpaceInKbAction,
  SET_editorTest_memoryLimitInKbAction,
  SET_editorTest_timeoutInMsAction,
  SET_isSubmitTestAction,
  SET_testIdAction,
  SET_testTypeIdAction,
  SET_weightAction
} from "../../../../reducers/exerciseEditorSite/dialogs/changeTestDialog/editorTestReducer";
import {ExerciseTestForBackend, FilePreviewFromBackend} from "../../../../../types/exerciseEditor";
import {MultiActions} from "../../../types";


export function setChangTest(test: ExerciseTestForBackend): MultiActions {
    return (dispatch) => {

      dispatch(setTestId(test.id))

      dispatch(setTestTypeId(test.testTypeId))
      dispatch(setEditorTestContent(test.content))
      dispatch(setDisplayNameAction(test.displayName))
      dispatch(setDisplayIndex(test.displayIndex))
      dispatch(setIsSubmitTest(test.isSubmitTest))
      dispatch(setWeight(test.weight))

      dispatch(setEditorTest_memoryLimitInKb(test.testSettings.memoryLimitInKb))
      dispatch(setEditorTest_timeoutInMs(test.testSettings.timeoutInMs))
      dispatch(setEditorTest_maxDiskSpaceInKb(test.testSettings.maxDiskSpaceInKb))

      dispatch(setEditorTest_files(test.files))
    }
}

export function setTestId(id: number): SET_testIdAction {
  return {
    type: ActionType.SET_testId,
    id
  }
}

export function setEditorTestContent(content: string): SET_contentAction {
  return {
    type: ActionType.SET_content,
    content
  }
}

export function setDisplayNameAction(displayName: string): SET_displayNameAction {
  return {
    type: ActionType.SET_displayName,
    displayName
  }
}


export function setDisplayIndex(displayIndex: number): SET_displayIndexAction {
  return {
    type: ActionType.SET_displayIndex,
    displayIndex
  }
}


export function setIsSubmitTest(isSubmitTest: boolean): SET_isSubmitTestAction {
  return {
    type: ActionType.SET_isSubmitTest,
    isSubmitTest
  }
}

export function setWeight(weight: number): SET_weightAction {
  return {
    type: ActionType.SET_weight,
    weight
  }
}

export function setTestTypeId(testTypeId: number): SET_testTypeIdAction {
  return {
    type: ActionType.SET_testTypeId,
    testTypeId
  }
}

export function setEditorTest_memoryLimitInKb(memoryLimitInKb: number): SET_editorTest_memoryLimitInKbAction {
  return {
    type: ActionType.SET_editorTest_memoryLimitInKb,
    memoryLimitInKb
  }
}

export function setEditorTest_timeoutInMs(timeoutInMs: number): SET_editorTest_timeoutInMsAction {
  return {
    type: ActionType.SET_editorTest_timeoutInMs,
    timeoutInMs
  }
}

export function setEditorTest_compileTimeoutInMs(compileTimeoutInMs: number): SET_editorTest_compileTimeoutInMsAction {
  return {
    type: ActionType.SET_editorTest_compileTimeoutInMs,
    compileTimeoutInMs
  }
}


export function setEditorTest_maxDiskSpaceInKb(maxDiskSpaceInKb: number): SET_editorTest_maxDiskSpaceInKbAction {
  return {
    type: ActionType.SET_editorTest_maxDiskSpaceInKb,
    maxDiskSpaceInKb
  }
}

export function setEditorTest_files(files: ReadonlyArray<FilePreviewFromBackend>): SET_editorTest_filesAction {
  return {
    type: ActionType.SET_editorTest_files,
    files
  }
}

