/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {TestSettingsFullBase} from "../../../../types/exerciseEditor";

export type State = TestSettingsFullBase


export const initial: State = {
  id: -1,
  timeoutInMs: 1000,
  memoryLimitInKb: 1000,
  maxDiskSpaceInKb: 1000,
  compileTimeoutInMs: 2000,
}


export interface SET_defaultTestSettingsAction extends ActionBase {
  readonly type: ActionType.SET_defaultTestSettings
  readonly defaultTestSettings: TestSettingsFullBase
}


export type AllActions =
  SET_defaultTestSettingsAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_defaultTestSettings:
      return {
        ...action.defaultTestSettings,
      }

    default:
      //somehow only working with 2 or more cases...
      //notExhaustive(action)
      return state
  }
}

